
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>IOS GCD定时器 / 憋错料</title>

    <meta name="description" content="IOS GCD定时器 提到定时器,NStimer肯定是我们最为熟悉的. 但是NStimer有着很大的缺点,并不准确. 通俗点说,就是它该做他的事了,但是由于其他事件的影响,Nstimer会放弃他应该做的. 而GCD定时器,是不会发生这种事情的. GCD严格按照规定好的规格去做事. 前面介绍RunLoop 的时候已经介绍了NSTimer. 这里就不在介绍了. 在这里着重介绍一下GCD定时器. 首先,我们知道NStimer是在RunLoop的基础上执行的,然而RunLoop是在GCD基础上实现的,所以说GCD可算是更加高">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">IOS GCD定时器</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<p>提到定时器，NStimer肯定是我们最为熟悉的。</p>
<p>但是NStimer有着很大的缺点，并不准确。</p>
<p>通俗点说，就是它该做他的事了，但是由于其他事件的影响，Nstimer会放弃他应该做的。</p>
<p>而GCD定时器，是不会发生这种事情的。</p>
<p>GCD严格按照规定好的规格去做事。</p>
<p>前面介绍RunLoop 的时候已经介绍了NSTimer。</p>
<p>这里就不在介绍了。</p>
<p>在这里着重介绍一下GCD定时器。</p>
<p>首先，我们知道NStimer是在RunLoop的基础上执行的，然而RunLoop是在GCD基础上实现的，所以说GCD可算是更加高级。</p>
<p>先看一下演示效果</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzMjAxNS5jbmJsb2dzLmNvbS9ibG9nLzkxMzM4Ny8yMDE2MDMvOTEzMzg3LTIwMTYwMzMwMjIxNjQ5MDA0LTQ4ODI5OTU1OS5naWY=.jpg" /></p>
<p>一些细节在代码注释中</p>
<pre>//
//  ViewController.m
//  CX GCD 定时器
//
//  Created by ma c on 16/3/30.
//  Copyright &copy; 2016年 xubaoaichiyu. All rights reserved.
//

#import "ViewController.h"

NSInteger count = 0;

@interface ViewController ()

//注意＊＊这里不需要??号 可以理解为dispatch_time_t 已经包含了
@property (nonatomic, strong)dispatch_source_t time;

@end

@implementation ViewController

- (void)viewDidLoad {
    [super viewDidLoad];
}

-(void)touchesBegan:(NSSet&lt;UITouch *&gt; *)touches withEvent:(UIEvent *)event{

    NSLog(@"欢迎来到旭宝爱吃鱼的博客");
    //获得队列
    dispatch_queue_t queue = dispatch_get_global_queue(0, 0);
    //创建一个定时器
    self.time = dispatch_source_create(DISPATCH_SOURCE_TYPE_TIMER, 0, 0, queue);
    //设置开始时间
    dispatch_time_t start = dispatch_time(DISPATCH_TIME_NOW, (int64_t)(3.0 * NSEC_PER_SEC));
    //设置时间间隔
    uint64_t interval = (uint64_t)(2.0* NSEC_PER_SEC);
    //设置定时器
    dispatch_source_set_timer(self.time, start, interval, 0);
    //设置回调
    dispatch_source_set_event_handler(self.time, ^{

        NSLog(@"旭宝爱吃鱼");
        //设置当执行五次是取消定时器
        count++;
        if(count == 5){

            dispatch_cancel(self.time);

        }
    });
    //由于定时器默认是暂停的所以我们启动一下
    //启动定时器
    dispatch_resume(self.time);

}
@end</pre>
<p>在前面说了，GCD是不会发挥不稳定的因此我们测试一下，在这里我们演示一下，就不展示代码了</p>
<p>（添加一个TextView即可）</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzMjAxNS5jbmJsb2dzLmNvbS9ibG9nLzkxMzM4Ny8yMDE2MDMvOTEzMzg3LTIwMTYwMzMwMjIyMjQwMjY5LTc4NjA3OTcyMC5naWY=.jpg" /></p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-20 15:36:24 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong>         </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>IOS GCD定时器的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/L3r26w3.html" rel="bookmark">iOS GCD中级篇 - dispatch&lowbar;group的理解及使用</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				前文我们讲了GCD基础篇,以及同步.异步,并发.并行几个概率的理解. 参考链接: iOS GCD基础篇 - 同步.异步,并发.并行的理解 现在讲一下dispatch_group的概念以及几种场景下的使用 1.关于dispatch_group 把一组任务提交到队列中,这些队列可以不相关,然后监听这组任务完成的事件. 最常见的几个方法: 1.dispatch_group_create创建一个调度任务组 2.dispatch_group_async 把一个任务异步提交到任务组里 3.dispatch_			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0dgONwM.html" rel="bookmark">IOS  GCD</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				UIButton * btn = [[UIButton alloc]initWithFrame:CGRectMake(100, 100, 100, 100)]; [btn setTitle:@&quot;default&quot;forState:UIControlStateNormal]; btn.backgroundColor = [UIColorblackColor]; [self.view addSubview:btn]; //情况一 dispatch_async(dispatch_get_glo			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MWd9Ja0.html" rel="bookmark">GCD定时器</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				GCD定时器 by 伍雪颖 + (GCDTimer *)repeatingTimer:(NSTimeInterval)seconds block:(void (^)(void))block { NSParameterAssert(seconds); NSParameterAssert(block); GCDTimer *timer = [[self alloc] init]; timer.block = block; timer.source = dispatch_source_create(D			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/49lKYn3.html" rel="bookmark">GCD dispatch&lowbar;source基本使用&comma;创建GCD定时器与NSTimer的区别</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				可以使用GCD创建定时器 创建定时器: dispatch_queue_t queue = dispatch_get_global_queue(DISPATCH_QUEUE_PRIORITY_DEFAULT, 0); dispatch_source_t timer = dispatch_source_create(DISPATCH_SOURCE_TYPE_TIMER, 0, 0, queue); self.timer = timer; // 定时任务调度设置,4秒后启动,每个5秒运行 dispat			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MBDN6J3.html" rel="bookmark">iOS GCD的常见API使用指南</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				iOS GCD使用指南 Grand Central Dispatch(GCD)是异步执行任务的技术之一.一般将应用程序中记述的线程管理用的代码在系统级中实现.开发者只需要定义想执行的任务并追加到适当的Dispatch Queue中,GCD就能生成必要的线程并计划执行任务.由于线程管理是作为系统的一部分来实现的,因此可统一管理,也可执行任务,这样就比以前的线程更有效率. Dispatch Queue Dispatch Queue是用来执行任务的队列,是GCD中最基本的元素之一. Dispatch			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0a2A5Q3.html" rel="bookmark">iOS GCD学习</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				GCD概念:Grand Central Dispatch 1.queue 队列 dispatch queue 分发队列 2.task  任务 3.thread 线程 task 是一个一个单独的任务(方法,函数,block) queue里存放的是一个或者多个task thread 为了保证task能顺利执行,queue会开辟适当的thread,在开辟的thread里面执行task queue分两种: 1.serialqueue(串行队列) 特点:任务先进先出.排在前面任务先执行,执行之后后面的任务			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3ZddZqM.html" rel="bookmark">runloop 和 CFRunLoop -  定时器 - NSTimer 和 GCD定时器</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1. 2. 1 #import &quot;ViewController.h&quot; 2 3 @interface ViewController () 4 @property (nonatomic, strong) dispatch_source_t timer; 5 @end 6 7 @implementation ViewController 8 9 -(void)touchesBegan:(NSSet&lt;UITouch *&gt; *)touches withEvent:(UIEvent *			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MDvOQe3.html" rel="bookmark">iOS GCD的 一次性执行、定时器、迭代、队列组</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
							</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MyARlYM.html" rel="bookmark">iOS常用定时器</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				UIScrollView 拖动时执行的是 UITrackingRunLoopMode,会导致暂停定时器,等恢复为 NSDefaultRunLoopMode 时才恢复定时器.所以如果需要定时器在 UIScrollView 拖动时也不影响的话,建议添加到 UITrackingRunLoopMode 或 NSRunLoopCommonModes 中: NSTimer *timer = [NSTimer timerWithTimeInterval:5 target:self selector:@sele			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/P47Wy14.html" rel="bookmark" class="title">Enterprise Solution 进销存管理软件 C&sol;S架构，支持64位系统 物流，资金流，信息流全面集成</a>
					<div>
						      定位  Target Customers 中小型生产制造企业,批发零售类,贸易企业 主要模块 Modules 采购.销售.库存.财务账款四大模块,包含企业运作过程中销售.采购.库存各岗位需 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4JDwYA0.html" rel="bookmark" class="title">树的基本操作</a>
					<div>
						判断两棵树是否相同 public class Solution { /** * @param a, b, the root of binary trees. * @return true if the ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MPdyYPM.html" rel="bookmark" class="title">I&sol;O系统、网络编程、XML</a>
					<div>
						I/O系统 输入流InputStream  File file = new File(&quot;E:\\ello&quot;); //找到指定文件 if(file.exists()){//文件是否存 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0aD7nkM.html" rel="bookmark" class="title">html5 EvnetSource 与 JSP页面结合使用</a>
					<div>
						最近一直在研究前端的技术,特别是html5的技术,本人觉得html5的发展将越来越好,废话少说.看到了EventSource,根据官方的说法是服务器向客户端的推送服务.自己想找一些例子看看,发现都是P ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3OR81P0.html" rel="bookmark" class="title">&lbrack;Uva12563&rsqb; Jin Ge Jin Qu hao （完全背包，dp）</a>
					<div>
						题目链接:https://vjudge.net/problem/UVA-12563 题意:n首歌要在m-1的时间内挑k首唱,现在希望在k尽可能大的情况下,时间尽可能长地唱.问最后最大k+1多大,最长时 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0xv5dn4.html" rel="bookmark" class="title">php执行一条insert插入两条数据其中一条乱码</a>
					<div>
						显然这就是编码问题,但是问题从哪来的呢, 我把文件编码以及代码的编码都设置成utf-8了,为什么还有这个问题于是我就开始写测试脚本 第一条 mysql_query('insert into table ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0a17vP0.html" rel="bookmark" class="title">X86 Booting Sequence</a>
					<div>
						1.BIOS 0xFFFF0電源正常啟動後,x86 CPU 會先執行 0xFFFF0,也就是 BIOS ROM 的進入點.由於 0xFFFF0 ~ 0xFFFFF 只有少的很可憐的 16 bytes, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MXvomQ3.html" rel="bookmark" class="title">进程及作业管理（二）</a>
					<div>
						概述: 本篇是上篇进程及作业管理(一)http://1992tao.blog.51cto.com/11606804/1851196的后续内容,将继续介绍进程相关的管理工具! ============= ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MoL6kb0.html" rel="bookmark" class="title">HDU 2414 Chessboard Dance （强行模拟）</a>
					<div>
						题目链接:HDU 2414 Chessboard Dance 题意:给出一张图,&gt;,&lt;,^,v表示人面对的方向,字母相当于是箱子,箱子可以推出边界,人保证不会做出边界,下面输入指令,按照指 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3vjb5o3.html" rel="bookmark" class="title">如何在CENTOS 6&period;5上使用WEBMIN快速配置openvpn</a>
					<div>
						近来VPN火热,很多人租个服务器,配置成VPN服务器.发现网络上的教程都是基于命令行的,大量文本文件的配置.后来发现配合linux中的webmin,可以快速在菜单界面完成. 现在简要介绍下在CENTO ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3qRgGN4.html" rel="bookmark" class="title">Ubuntu安装gevent</a>
					<div>
						今天在安装包的过程中,按照网上的文章,出错,找了很久,最后才安装成功,希望能解决以后大家遇到的问题 Gevent是一个基于greenlet的Python的并发框架,以赖于greenlet和libeve ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0nRn8o0.html" rel="bookmark" class="title">java获取程序执行时间</a>
					<div>
						第一种是以毫秒为单位计算的. //伪代码 long startTime=System.currentTimeMillis(); //获取开始时间 doSomeThing(); //测试的代码段 lon ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0Rkqvq3.html" rel="bookmark" class="title">cxf 整合 spring 时 java&period;lang&period;VerifyError异常</a>
					<div>
						异常信息主要有两个,Falling off the end of the code 和 illegal instruction found at offset 1: java.lang.VerifyE ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MmmvP1M.html" rel="bookmark" class="title">JDBC操作</a>
					<div>
						一.JDBC: Java Database Connection 表示数据库连接,是Java中专门提供的一组用于操作数据库的标准,所有的数据库生产商如果想为Java提供支持, 则必须支持此标准.JDB ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0YLlNNM.html" rel="bookmark" class="title">zlib流式解压</a>
					<div>
						zlib实现解压的例子官方已经给出 http://www.zlib.net/zlib_how.html 最常见的解压方式就是现成从堆分配出适合大小的内存,直接向这个内存里解压,这样是不错的,一些情况下 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0n7AWV3.html" rel="bookmark" class="title">java&period;net&period;Url类的应用（网络编程）</a>
					<div>
						一.认识URL 类 URL 代表一个统一资源定位符,它是指向互联网&quot;资源&quot;的指针.资源可以是简单的文件或目录,也可以是更为复杂的对象的引用,例如对数据库或搜索引擎的查询. 简单的可 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0dEkQg3.html" rel="bookmark" class="title">ANSI&lowbar;common-lisp</a>
					<div>
						前言 本书的目的是快速及全面的教你 Common Lisp 的有关知识.它实际上包含两本书.前半部分用大量的例子来解释 Common Lisp 里面重要的概念.后半部分是一个最新 Common Lis ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4AnkndM.html" rel="bookmark" class="title">HTML5 实现橡皮擦的擦除效果</a>
					<div>
						声明:本文为原创文章,如需转载,请注明来源WAxes,谢谢! 最近项目刚好用到这种效果,也就是有点像刮刮卡一样,在移动设备上,把某张图片刮掉显示出另一张图片.效果图如下:  DEMO请戳右:DEMO  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MDq2Np0.html" rel="bookmark" class="title">将参数字符串中的字符反向排列</a>
					<div>
						//编写一个函数reverse_string(char * string)(递归实现) //实现:将参数字符串中的字符反向排列. //要求:不能使用C函数库中的字符串操作函数. //第一种方法:递归法 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0nwGaK3.html" rel="bookmark" class="title">【LeetCode OJ 237】Delete Node in a Linked List</a>
					<div>
						题目链接:https://leetcode.com/problems/delete-node-in-a-linked-list/ 题目:Write a function to delete a nod ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 10 q. 0.028 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
